;;;; Rust mode configuration.
;; Add rust load hooks.
(use-package flycheck
             :hook (prog-mode . flycheck-mode))

(use-package company
             :hook (prog-mode . company-mode)
             :config (setq company-tooltip-align-annotations t)
             (setq company-minimum-prefix-length 1))

(use-package lsp-mode
             :commands lsp
             :config (require 'lsp-clients))

(use-package lsp-ui
             :commands lsp-ui-mode
             :bind (:map lsp-ui-mode-map
                         ("M-."  . lsp-ui-peek-find-definitions)
                         ("M-,"  . lsp-ui-peek-jump-backward)
                         ("M-?"  . lsp-ui-peek-find-references)
                         ("C-c u"   . lsp-ui-imenu)
                         ("C-c C-a" . lsp-ui-sideline-apply-code-actions))
             :config (setq lsp-ui-peek-enable t))

(use-package rust-mode
             :config
             (setq rust-format-on-save t)
             :hook (rust-mode . lsp))


;; Add keybindings for interacting with Cargo
(use-package cargo
             :hook (rust-mode . cargo-minor-mode))

(use-package flycheck-rust
             :config (add-hook 'flycheck-mode-hook #'flycheck-rust-setup))

(provide 'jenga-rust)
